/**
 * {}
 * @author yutent<yutent.io@gmail.com>
 * @date 2023/09/04 19:18:28
 */

import { nextTick } from 'wkit'

export function noop() {}

export const docker = {
  containers(all = true) {
    return native.handler('docker', { action: 'containers', all })
  },

  images() {
    return native.handler('docker', { action: 'images' })
  },

  volumes() {
    return native.handler('docker', { action: 'volumes' })
  },

  networks() {
    return native.handler('docker', { action: 'networks' })
  },

  services() {
    return native.handler('docker', { action: 'services' })
  },

  rm(id) {
    return native.handler('docker', { action: 'rm', id })
  },

  rmi(id) {
    return native.handler('docker', { action: 'rmi', id })
  },

  start(id) {
    return native.handler('docker', { action: 'start', id })
  },

  stop(id) {
    return native.handler('docker', { action: 'stop', id })
  },

  service: {
    stop(config) {
      return native.handler('docker', { action: 'service-stop', config })
    }
  },

  volume: {
    prune() {
      return native.handler('docker', { action: 'volume-prune' })
    },
    rm(name) {
      return native.handler('docker', { action: 'volume-rm', name })
    }
  },

  network: {
    prune() {
      return native.handler('docker', { action: 'network-prune' })
    },
    rm(id) {
      return native.handler('docker', { action: 'network-rm', id })
    }
  }
}
